#include "ballarith-exports.h"
#include "scc-core.h"
#include "../system/supervisorinterface.h"
# line 18 "../../../../Macaulay2/d/ballarith.d"

	#ifdef HAVE_ARB_H
	# include <arb_hypgeom.h>
	# include <acb_hypgeom.h>
	#endif
	#ifdef HAVE_FLINT_ARB_H
	# include <flint/arb_hypgeom.h>
	# include <flint/acb_hypgeom.h>
	#endif
	
# line 37 "../../../../Macaulay2/d/ballarith.d"
static arb_ptr newRRball(){
  # line 37 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr tmp_;
  # line 37 "../../../../Macaulay2/d/ballarith.d"
  tmp_ = (arb_ptr) GC_MALLOC(sizeof(*((arb_ptr)0)));
  if (0 == tmp_) outofmem2((size_t)sizeof(*((arb_ptr)0)));
  # line 37 "../../../../Macaulay2/d/ballarith.d"
  arb_init(tmp_);
  # line 39 "../../../../Macaulay2/d/ballarith.d"
  return tmp_;
  # line 39 "../../../../Macaulay2/d/ballarith.d"
  }
# line 44 "../../../../Macaulay2/d/ballarith.d"
static arb_ptr toRRball(mpfr_srcptr x,mpfr_srcptr y,unsigned long prec){
  # line 44 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr z;
  # line 44 "../../../../Macaulay2/d/ballarith.d"
  z = newRRball();
  # line 45 "../../../../Macaulay2/d/ballarith.d"
  arb_set_interval_mpfr(z, x, y, prec);
  # line 46 "../../../../Macaulay2/d/ballarith.d"
  return z;
  # line 46 "../../../../Macaulay2/d/ballarith.d"
  }
# line 47 "../../../../Macaulay2/d/ballarith.d"
static arb_ptr toRRball_1(mpfr_srcptr x){
  # line 47 "../../../../Macaulay2/d/ballarith.d"
  return toRRball(x, x, gmp_precision(x));
  # line 47 "../../../../Macaulay2/d/ballarith.d"
  }
# line 48 "../../../../Macaulay2/d/ballarith.d"
static arb_ptr toRRball_2(mpfi_srcptr x){
  # line 48 "../../../../Macaulay2/d/ballarith.d"
  return toRRball(gmp_leftRR(x), gmp_rightRR(x), gmp_precision_1(x));
  # line 48 "../../../../Macaulay2/d/ballarith.d"
  }
# line 51 "../../../../Macaulay2/d/ballarith.d"
static mpfr_srcptr toRR(arb_ptr x,unsigned long prec){
  # line 51 "../../../../Macaulay2/d/ballarith.d"
  mpfr_ptr y_1;
  # line 51 "../../../../Macaulay2/d/ballarith.d"
  y_1 = gmp_newRRmutable(prec);
  # line 52 "../../../../Macaulay2/d/ballarith.d"
  arf_get_mpfr(y_1, arb_midref(x), MPFR_RNDN);
  # line 53 "../../../../Macaulay2/d/ballarith.d"
  return gmp_moveToRRandclear(y_1);
  # line 53 "../../../../Macaulay2/d/ballarith.d"
  }
# line 56 "../../../../Macaulay2/d/ballarith.d"
static mpfi_srcptr toRRi(arb_ptr x,unsigned long prec){
  # line 56 "../../../../Macaulay2/d/ballarith.d"
  mpfi_ptr y_2;
  # line 56 "../../../../Macaulay2/d/ballarith.d"
  y_2 = gmp_newRRimutable(prec);
  # line 57 "../../../../Macaulay2/d/ballarith.d"
  arb_get_interval_mpfr((mpfr_ptr)&y_2->left, (mpfr_ptr)&y_2->right, x);
  # line 59 "../../../../Macaulay2/d/ballarith.d"
  return gmp_moveToRRiandclear(y_2);
  # line 59 "../../../../Macaulay2/d/ballarith.d"
  }
# line 62 "../../../../Macaulay2/d/ballarith.d"
static mpfi_srcptr moveToRRiandclear(arb_ptr x,unsigned long prec){
  # line 62 "../../../../Macaulay2/d/ballarith.d"
  mpfi_srcptr r;
  # line 62 "../../../../Macaulay2/d/ballarith.d"
  r = toRRi(x, prec);
  # line 63 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(x);
  # line 64 "../../../../Macaulay2/d/ballarith.d"
  return r;
  # line 64 "../../../../Macaulay2/d/ballarith.d"
  }
# line 68 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_eint(mpfi_srcptr x){
  # line 68 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_3;
  # line 68 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_1;
  # line 68 "../../../../Macaulay2/d/ballarith.d"
  y_3 = toRRball_2(x);
  # line 69 "../../../../Macaulay2/d/ballarith.d"
  r_1 = newRRball();
  # line 70 "../../../../Macaulay2/d/ballarith.d"
  arb_hypgeom_ei(r_1, y_3, gmp_precision_1(x));
  # line 71 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_3);
  # line 72 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_1, gmp_precision_1(x));
  # line 72 "../../../../Macaulay2/d/ballarith.d"
  }
# line 75 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_Gamma(mpfi_srcptr x){
  # line 75 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_4;
  # line 75 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_2;
  # line 75 "../../../../Macaulay2/d/ballarith.d"
  y_4 = toRRball_2(x);
  # line 76 "../../../../Macaulay2/d/ballarith.d"
  r_2 = newRRball();
  # line 77 "../../../../Macaulay2/d/ballarith.d"
  arb_gamma(r_2, y_4, gmp_precision_1(x));
  # line 78 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_4);
  # line 79 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_2, gmp_precision_1(x));
  # line 79 "../../../../Macaulay2/d/ballarith.d"
  }
# line 82 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_Gamma_1(mpfi_srcptr z,mpfi_srcptr w){
  # line 82 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_1;
  # line 82 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr x_1;
  # line 82 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_5;
  # line 82 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_3;
  # line 82 "../../../../Macaulay2/d/ballarith.d"
  prec_1 = gmp_min_3(gmp_precision_1(z), gmp_precision_1(w));
  # line 83 "../../../../Macaulay2/d/ballarith.d"
  x_1 = toRRball_2(z);
  # line 84 "../../../../Macaulay2/d/ballarith.d"
  y_5 = toRRball_2(w);
  # line 85 "../../../../Macaulay2/d/ballarith.d"
  r_3 = newRRball();
  # line 86 "../../../../Macaulay2/d/ballarith.d"
  arb_hypgeom_gamma_upper(r_3, x_1, y_5, 0, prec_1);
  # line 88 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(x_1);
  # line 89 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_5);
  # line 90 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_3, prec_1);
  # line 90 "../../../../Macaulay2/d/ballarith.d"
  }
# line 93 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_regularizedGamma(mpfi_srcptr z,mpfi_srcptr w){
  # line 93 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_2;
  # line 93 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr x_2;
  # line 93 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_6;
  # line 93 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_4;
  # line 93 "../../../../Macaulay2/d/ballarith.d"
  prec_2 = gmp_min_3(gmp_precision_1(z), gmp_precision_1(w));
  # line 94 "../../../../Macaulay2/d/ballarith.d"
  x_2 = toRRball_2(z);
  # line 95 "../../../../Macaulay2/d/ballarith.d"
  y_6 = toRRball_2(w);
  # line 96 "../../../../Macaulay2/d/ballarith.d"
  r_4 = newRRball();
  # line 97 "../../../../Macaulay2/d/ballarith.d"
  arb_hypgeom_gamma_upper(r_4, x_2, y_6, 1, prec_2);
  # line 99 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(x_2);
  # line 100 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_6);
  # line 101 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_4, prec_2);
  # line 101 "../../../../Macaulay2/d/ballarith.d"
  }
# line 104 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_Digamma(mpfi_srcptr x){
  # line 104 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_7;
  # line 104 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_5;
  # line 104 "../../../../Macaulay2/d/ballarith.d"
  y_7 = toRRball_2(x);
  # line 105 "../../../../Macaulay2/d/ballarith.d"
  r_5 = newRRball();
  # line 106 "../../../../Macaulay2/d/ballarith.d"
  arb_digamma(r_5, y_7, gmp_precision_1(x));
  # line 107 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_7);
  # line 108 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_5, gmp_precision_1(x));
  # line 108 "../../../../Macaulay2/d/ballarith.d"
  }
# line 111 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_lgamma(mpfi_srcptr x){
  # line 111 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_8;
  # line 111 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_6;
  # line 111 "../../../../Macaulay2/d/ballarith.d"
  y_8 = toRRball_2(x);
  # line 112 "../../../../Macaulay2/d/ballarith.d"
  r_6 = newRRball();
  # line 113 "../../../../Macaulay2/d/ballarith.d"
  arb_lgamma(r_6, y_8, gmp_precision_1(x));
  # line 114 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_8);
  # line 115 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_6, gmp_precision_1(x));
  # line 115 "../../../../Macaulay2/d/ballarith.d"
  }
# line 118 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_zeta(mpfi_srcptr x){
  # line 118 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_9;
  # line 118 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_7;
  # line 118 "../../../../Macaulay2/d/ballarith.d"
  y_9 = toRRball_2(x);
  # line 119 "../../../../Macaulay2/d/ballarith.d"
  r_7 = newRRball();
  # line 120 "../../../../Macaulay2/d/ballarith.d"
  arb_zeta(r_7, y_9, gmp_precision_1(x));
  # line 121 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_9);
  # line 122 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_7, gmp_precision_1(x));
  # line 122 "../../../../Macaulay2/d/ballarith.d"
  }
# line 125 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_erf(mpfi_srcptr x){
  # line 125 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_10;
  # line 125 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_8;
  # line 125 "../../../../Macaulay2/d/ballarith.d"
  y_10 = toRRball_2(x);
  # line 126 "../../../../Macaulay2/d/ballarith.d"
  r_8 = newRRball();
  # line 127 "../../../../Macaulay2/d/ballarith.d"
  arb_hypgeom_erf(r_8, y_10, gmp_precision_1(x));
  # line 128 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_10);
  # line 129 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_8, gmp_precision_1(x));
  # line 129 "../../../../Macaulay2/d/ballarith.d"
  }
# line 132 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_erfc(mpfi_srcptr x){
  # line 132 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_11;
  # line 132 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_9;
  # line 132 "../../../../Macaulay2/d/ballarith.d"
  y_11 = toRRball_2(x);
  # line 133 "../../../../Macaulay2/d/ballarith.d"
  r_9 = newRRball();
  # line 134 "../../../../Macaulay2/d/ballarith.d"
  arb_hypgeom_erfc(r_9, y_11, gmp_precision_1(x));
  # line 135 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_11);
  # line 136 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_9, gmp_precision_1(x));
  # line 136 "../../../../Macaulay2/d/ballarith.d"
  }
# line 139 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_inverseErf(mpfi_srcptr x){
  # line 139 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_12;
  # line 139 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_10;
  # line 139 "../../../../Macaulay2/d/ballarith.d"
  y_12 = toRRball_2(x);
  # line 140 "../../../../Macaulay2/d/ballarith.d"
  r_10 = newRRball();
  # line 141 "../../../../Macaulay2/d/ballarith.d"
  arb_hypgeom_erfinv(r_10, y_12, gmp_precision_1(x));
  # line 142 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_12);
  # line 143 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_10, gmp_precision_1(x));
  # line 143 "../../../../Macaulay2/d/ballarith.d"
  }
# line 146 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_BesselJ(mpfi_srcptr z,mpfi_srcptr w){
  # line 146 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_3;
  # line 146 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr x_3;
  # line 146 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_13;
  # line 146 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_11;
  # line 146 "../../../../Macaulay2/d/ballarith.d"
  prec_3 = gmp_min_3(gmp_precision_1(z), gmp_precision_1(w));
  # line 147 "../../../../Macaulay2/d/ballarith.d"
  x_3 = toRRball_2(z);
  # line 148 "../../../../Macaulay2/d/ballarith.d"
  y_13 = toRRball_2(w);
  # line 149 "../../../../Macaulay2/d/ballarith.d"
  r_11 = newRRball();
  # line 150 "../../../../Macaulay2/d/ballarith.d"
  arb_hypgeom_bessel_j(r_11, x_3, y_13, prec_3);
  # line 151 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(x_3);
  # line 152 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_13);
  # line 153 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_11, prec_3);
  # line 153 "../../../../Macaulay2/d/ballarith.d"
  }
# line 156 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_BesselY(mpfi_srcptr z,mpfi_srcptr w){
  # line 156 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_4;
  # line 156 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr x_4;
  # line 156 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_14;
  # line 156 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_12;
  # line 156 "../../../../Macaulay2/d/ballarith.d"
  prec_4 = gmp_min_3(gmp_precision_1(z), gmp_precision_1(w));
  # line 157 "../../../../Macaulay2/d/ballarith.d"
  x_4 = toRRball_2(z);
  # line 158 "../../../../Macaulay2/d/ballarith.d"
  y_14 = toRRball_2(w);
  # line 159 "../../../../Macaulay2/d/ballarith.d"
  r_12 = newRRball();
  # line 160 "../../../../Macaulay2/d/ballarith.d"
  arb_hypgeom_bessel_y(r_12, x_4, y_14, prec_4);
  # line 161 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(x_4);
  # line 162 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_14);
  # line 163 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_12, prec_4);
  # line 163 "../../../../Macaulay2/d/ballarith.d"
  }
# line 166 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_Beta(mpfi_srcptr z,mpfi_srcptr w){
  # line 166 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_5;
  # line 166 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr x_5;
  # line 166 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_15;
  # line 166 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr v;
  # line 166 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_13;
  # line 166 "../../../../Macaulay2/d/ballarith.d"
  prec_5 = gmp_min_3(gmp_precision_1(z), gmp_precision_1(w));
  # line 167 "../../../../Macaulay2/d/ballarith.d"
  x_5 = toRRball_2(z);
  # line 168 "../../../../Macaulay2/d/ballarith.d"
  y_15 = toRRball_2(w);
  # line 169 "../../../../Macaulay2/d/ballarith.d"
  v = toRRball_2(gmp_toRRi_6(1, prec_5));
  # line 170 "../../../../Macaulay2/d/ballarith.d"
  r_13 = newRRball();
  # line 171 "../../../../Macaulay2/d/ballarith.d"
  arb_hypgeom_beta_lower(r_13, x_5, y_15, v, 0, prec_5);
  # line 173 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(x_5);
  # line 174 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_15);
  # line 175 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_13, prec_5);
  # line 175 "../../../../Macaulay2/d/ballarith.d"
  }
# line 178 "../../../../Macaulay2/d/ballarith.d"
mpfi_srcptr ballarith_regularizedBeta(mpfi_srcptr u,mpfi_srcptr v,mpfi_srcptr w){
  # line 178 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_6;
  # line 178 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr x_6;
  # line 178 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_16;
  # line 178 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr z_1;
  # line 178 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr r_14;
  # line 178 "../../../../Macaulay2/d/ballarith.d"
  prec_6 = gmp_min_3(gmp_min_3(gmp_precision_1(u), gmp_precision_1(v)), gmp_precision_1(w));
  # line 179 "../../../../Macaulay2/d/ballarith.d"
  x_6 = toRRball_2(u);
  # line 180 "../../../../Macaulay2/d/ballarith.d"
  y_16 = toRRball_2(v);
  # line 181 "../../../../Macaulay2/d/ballarith.d"
  z_1 = toRRball_2(w);
  # line 182 "../../../../Macaulay2/d/ballarith.d"
  r_14 = newRRball();
  # line 183 "../../../../Macaulay2/d/ballarith.d"
  arb_hypgeom_beta_lower(r_14, y_16, z_1, x_6, 1, prec_6);
  # line 185 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(x_6);
  # line 186 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_16);
  # line 187 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(z_1);
  # line 188 "../../../../Macaulay2/d/ballarith.d"
  return moveToRRiandclear(r_14, prec_6);
  # line 188 "../../../../Macaulay2/d/ballarith.d"
  }
# line 196 "../../../../Macaulay2/d/ballarith.d"
static acb_ptr newCCball(){
  # line 196 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr tmp__1;
  # line 196 "../../../../Macaulay2/d/ballarith.d"
  tmp__1 = (acb_ptr) GC_MALLOC(sizeof(*((acb_ptr)0)));
  if (0 == tmp__1) outofmem2((size_t)sizeof(*((acb_ptr)0)));
  # line 196 "../../../../Macaulay2/d/ballarith.d"
  acb_init(tmp__1);
  # line 198 "../../../../Macaulay2/d/ballarith.d"
  return tmp__1;
  # line 198 "../../../../Macaulay2/d/ballarith.d"
  }
# line 203 "../../../../Macaulay2/d/ballarith.d"
static acb_ptr toCCball(gmp_CC z){
  # line 203 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr x_7;
  # line 203 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_17;
  # line 203 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr w_1;
  # line 203 "../../../../Macaulay2/d/ballarith.d"
  x_7 = toRRball_1(gmp_realPart(z));
  # line 204 "../../../../Macaulay2/d/ballarith.d"
  y_17 = toRRball_1(gmp_imaginaryPart(z));
  # line 205 "../../../../Macaulay2/d/ballarith.d"
  w_1 = newCCball();
  # line 206 "../../../../Macaulay2/d/ballarith.d"
  acb_set_arb_arb(w_1, x_7, y_17);
  # line 207 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(x_7);
  # line 208 "../../../../Macaulay2/d/ballarith.d"
  arb_clear(y_17);
  # line 209 "../../../../Macaulay2/d/ballarith.d"
  return w_1;
  # line 209 "../../../../Macaulay2/d/ballarith.d"
  }
# line 212 "../../../../Macaulay2/d/ballarith.d"
static gmp_CC toCC(acb_ptr z,unsigned long prec){
  # line 212 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr x_8;
  # line 212 "../../../../Macaulay2/d/ballarith.d"
  arb_ptr y_18;
  # line 212 "../../../../Macaulay2/d/ballarith.d"
  x_8 = acb_realref(z);
  # line 213 "../../../../Macaulay2/d/ballarith.d"
  y_18 = acb_imagref(z);
  # line 214 "../../../../Macaulay2/d/ballarith.d"
  return gmp_toCC(toRR(x_8, prec), toRR(y_18, prec));
  # line 214 "../../../../Macaulay2/d/ballarith.d"
  }
# line 217 "../../../../Macaulay2/d/ballarith.d"
static gmp_CC moveToCCandclear(acb_ptr z,unsigned long prec){
  # line 217 "../../../../Macaulay2/d/ballarith.d"
  gmp_CC r_15;
  # line 217 "../../../../Macaulay2/d/ballarith.d"
  r_15 = toCC(z, prec);
  # line 218 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(z);
  # line 219 "../../../../Macaulay2/d/ballarith.d"
  return r_15;
  # line 219 "../../../../Macaulay2/d/ballarith.d"
  }
# line 222 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_eint_1(gmp_CC z){
  # line 222 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr w_2;
  # line 222 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_16;
  # line 222 "../../../../Macaulay2/d/ballarith.d"
  w_2 = toCCball(z);
  # line 223 "../../../../Macaulay2/d/ballarith.d"
  r_16 = newCCball();
  # line 224 "../../../../Macaulay2/d/ballarith.d"
  acb_hypgeom_ei(r_16, w_2, gmp_precision_2(z));
  # line 225 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(w_2);
  # line 226 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_16, gmp_precision_2(z));
  # line 226 "../../../../Macaulay2/d/ballarith.d"
  }
# line 229 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_Gamma_2(gmp_CC z){
  # line 229 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr w_3;
  # line 229 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_17;
  # line 229 "../../../../Macaulay2/d/ballarith.d"
  w_3 = toCCball(z);
  # line 230 "../../../../Macaulay2/d/ballarith.d"
  r_17 = newCCball();
  # line 231 "../../../../Macaulay2/d/ballarith.d"
  acb_gamma(r_17, w_3, gmp_precision_2(z));
  # line 232 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(w_3);
  # line 233 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_17, gmp_precision_2(z));
  # line 233 "../../../../Macaulay2/d/ballarith.d"
  }
# line 236 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_Gamma_3(gmp_CC z,gmp_CC w){
  # line 236 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_7;
  # line 236 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr x_9;
  # line 236 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr y_19;
  # line 236 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_18;
  # line 236 "../../../../Macaulay2/d/ballarith.d"
  prec_7 = gmp_min_3(gmp_precision_2(z), gmp_precision_2(w));
  # line 237 "../../../../Macaulay2/d/ballarith.d"
  x_9 = toCCball(z);
  # line 238 "../../../../Macaulay2/d/ballarith.d"
  y_19 = toCCball(w);
  # line 239 "../../../../Macaulay2/d/ballarith.d"
  r_18 = newCCball();
  # line 240 "../../../../Macaulay2/d/ballarith.d"
  acb_hypgeom_gamma_upper(r_18, x_9, y_19, 0, prec_7);
  # line 242 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(x_9);
  # line 243 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(y_19);
  # line 244 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_18, prec_7);
  # line 244 "../../../../Macaulay2/d/ballarith.d"
  }
# line 247 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_regularizedGamma_1(gmp_CC z,gmp_CC w){
  # line 247 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_8;
  # line 247 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr x_10;
  # line 247 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr y_20;
  # line 247 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_19;
  # line 247 "../../../../Macaulay2/d/ballarith.d"
  prec_8 = gmp_min_3(gmp_precision_2(z), gmp_precision_2(w));
  # line 248 "../../../../Macaulay2/d/ballarith.d"
  x_10 = toCCball(z);
  # line 249 "../../../../Macaulay2/d/ballarith.d"
  y_20 = toCCball(w);
  # line 250 "../../../../Macaulay2/d/ballarith.d"
  r_19 = newCCball();
  # line 251 "../../../../Macaulay2/d/ballarith.d"
  acb_hypgeom_gamma_upper(r_19, x_10, y_20, 1, prec_8);
  # line 253 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(x_10);
  # line 254 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(y_20);
  # line 255 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_19, prec_8);
  # line 255 "../../../../Macaulay2/d/ballarith.d"
  }
# line 258 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_Digamma_1(gmp_CC z){
  # line 258 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr w_4;
  # line 258 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_20;
  # line 258 "../../../../Macaulay2/d/ballarith.d"
  w_4 = toCCball(z);
  # line 259 "../../../../Macaulay2/d/ballarith.d"
  r_20 = newCCball();
  # line 260 "../../../../Macaulay2/d/ballarith.d"
  acb_digamma(r_20, w_4, gmp_precision_2(z));
  # line 261 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(w_4);
  # line 262 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_20, gmp_precision_2(z));
  # line 262 "../../../../Macaulay2/d/ballarith.d"
  }
# line 265 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_lgamma_1(gmp_CC z){
  # line 265 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr w_5;
  # line 265 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_21;
  # line 265 "../../../../Macaulay2/d/ballarith.d"
  w_5 = toCCball(z);
  # line 266 "../../../../Macaulay2/d/ballarith.d"
  r_21 = newCCball();
  # line 267 "../../../../Macaulay2/d/ballarith.d"
  acb_lgamma(r_21, w_5, gmp_precision_2(z));
  # line 268 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(w_5);
  # line 269 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_21, gmp_precision_2(z));
  # line 269 "../../../../Macaulay2/d/ballarith.d"
  }
# line 272 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_zeta_1(gmp_CC z){
  # line 272 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr w_6;
  # line 272 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_22;
  # line 272 "../../../../Macaulay2/d/ballarith.d"
  w_6 = toCCball(z);
  # line 273 "../../../../Macaulay2/d/ballarith.d"
  r_22 = newCCball();
  # line 274 "../../../../Macaulay2/d/ballarith.d"
  acb_zeta(r_22, w_6, gmp_precision_2(z));
  # line 275 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(w_6);
  # line 276 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_22, gmp_precision_2(z));
  # line 276 "../../../../Macaulay2/d/ballarith.d"
  }
# line 279 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_erf_1(gmp_CC z){
  # line 279 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr w_7;
  # line 279 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_23;
  # line 279 "../../../../Macaulay2/d/ballarith.d"
  w_7 = toCCball(z);
  # line 280 "../../../../Macaulay2/d/ballarith.d"
  r_23 = newCCball();
  # line 281 "../../../../Macaulay2/d/ballarith.d"
  acb_hypgeom_erf(r_23, w_7, gmp_precision_2(z));
  # line 282 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(w_7);
  # line 283 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_23, gmp_precision_2(z));
  # line 283 "../../../../Macaulay2/d/ballarith.d"
  }
# line 286 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_erfc_1(gmp_CC z){
  # line 286 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr w_8;
  # line 286 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_24;
  # line 286 "../../../../Macaulay2/d/ballarith.d"
  w_8 = toCCball(z);
  # line 287 "../../../../Macaulay2/d/ballarith.d"
  r_24 = newCCball();
  # line 288 "../../../../Macaulay2/d/ballarith.d"
  acb_hypgeom_erfc(r_24, w_8, gmp_precision_2(z));
  # line 289 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(w_8);
  # line 290 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_24, gmp_precision_2(z));
  # line 290 "../../../../Macaulay2/d/ballarith.d"
  }
# line 293 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_BesselJ_1(gmp_CC z,gmp_CC w){
  # line 293 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_9;
  # line 293 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr x_11;
  # line 293 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr y_21;
  # line 293 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_25;
  # line 293 "../../../../Macaulay2/d/ballarith.d"
  prec_9 = gmp_min_3(gmp_precision_2(z), gmp_precision_2(w));
  # line 294 "../../../../Macaulay2/d/ballarith.d"
  x_11 = toCCball(z);
  # line 295 "../../../../Macaulay2/d/ballarith.d"
  y_21 = toCCball(w);
  # line 296 "../../../../Macaulay2/d/ballarith.d"
  r_25 = newCCball();
  # line 297 "../../../../Macaulay2/d/ballarith.d"
  acb_hypgeom_bessel_j(r_25, x_11, y_21, prec_9);
  # line 298 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(x_11);
  # line 299 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(y_21);
  # line 300 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_25, prec_9);
  # line 300 "../../../../Macaulay2/d/ballarith.d"
  }
# line 303 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_BesselY_1(gmp_CC z,gmp_CC w){
  # line 303 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_10;
  # line 303 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr x_12;
  # line 303 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr y_22;
  # line 303 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_26;
  # line 303 "../../../../Macaulay2/d/ballarith.d"
  prec_10 = gmp_min_3(gmp_precision_2(z), gmp_precision_2(w));
  # line 304 "../../../../Macaulay2/d/ballarith.d"
  x_12 = toCCball(z);
  # line 305 "../../../../Macaulay2/d/ballarith.d"
  y_22 = toCCball(w);
  # line 306 "../../../../Macaulay2/d/ballarith.d"
  r_26 = newCCball();
  # line 307 "../../../../Macaulay2/d/ballarith.d"
  acb_hypgeom_bessel_y(r_26, x_12, y_22, prec_10);
  # line 308 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(x_12);
  # line 309 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(y_22);
  # line 310 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_26, prec_10);
  # line 310 "../../../../Macaulay2/d/ballarith.d"
  }
# line 313 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_Beta_1(gmp_CC z,gmp_CC w){
  # line 313 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_11;
  # line 313 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr x_13;
  # line 313 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr y_23;
  # line 313 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr v_1;
  # line 313 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_27;
  # line 313 "../../../../Macaulay2/d/ballarith.d"
  prec_11 = gmp_min_3(gmp_precision_2(z), gmp_precision_2(w));
  # line 314 "../../../../Macaulay2/d/ballarith.d"
  x_13 = toCCball(z);
  # line 315 "../../../../Macaulay2/d/ballarith.d"
  y_23 = toCCball(w);
  # line 316 "../../../../Macaulay2/d/ballarith.d"
  v_1 = toCCball(gmp_toCC_10(1, prec_11));
  # line 317 "../../../../Macaulay2/d/ballarith.d"
  r_27 = newCCball();
  # line 318 "../../../../Macaulay2/d/ballarith.d"
  acb_hypgeom_beta_lower(r_27, x_13, y_23, v_1, 0, prec_11);
  # line 320 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(x_13);
  # line 321 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(y_23);
  # line 322 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_27, prec_11);
  # line 322 "../../../../Macaulay2/d/ballarith.d"
  }
# line 325 "../../../../Macaulay2/d/ballarith.d"
gmp_CC ballarith_regularizedBeta_1(gmp_CC u,gmp_CC v,gmp_CC w){
  # line 325 "../../../../Macaulay2/d/ballarith.d"
  unsigned long prec_12;
  # line 325 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr x_14;
  # line 325 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr y_24;
  # line 325 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr z_2;
  # line 325 "../../../../Macaulay2/d/ballarith.d"
  acb_ptr r_28;
  # line 325 "../../../../Macaulay2/d/ballarith.d"
  prec_12 = gmp_min_3(gmp_min_3(gmp_precision_2(u), gmp_precision_2(v)), gmp_precision_2(w));
  # line 326 "../../../../Macaulay2/d/ballarith.d"
  x_14 = toCCball(u);
  # line 327 "../../../../Macaulay2/d/ballarith.d"
  y_24 = toCCball(v);
  # line 328 "../../../../Macaulay2/d/ballarith.d"
  z_2 = toCCball(w);
  # line 329 "../../../../Macaulay2/d/ballarith.d"
  r_28 = newCCball();
  # line 330 "../../../../Macaulay2/d/ballarith.d"
  acb_hypgeom_beta_lower(r_28, y_24, z_2, x_14, 1, prec_12);
  # line 332 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(x_14);
  # line 333 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(y_24);
  # line 334 "../../../../Macaulay2/d/ballarith.d"
  acb_clear(z_2);
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  return moveToCCandclear(r_28, prec_12);
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  }
# line 335 "../../../../Macaulay2/d/ballarith.d"
static void ballarith__thread_prepare();
# line 335 "../../../../Macaulay2/d/ballarith.d"
static void ballarith__final();
# line 335 "../../../../Macaulay2/d/ballarith.d"
void ballarith__prepare(){
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  static struct FUNCTION_CELL this_final, this_thread_prepare;
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  static int called_yet = 0;
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  if (called_yet) return; else called_yet = 1;
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  gmp__prepare();
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  this_thread_prepare.func = ballarith__thread_prepare;
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  this_thread_prepare.next = thread_prepare_list;
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  thread_prepare_list = &this_thread_prepare;
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  this_final.func = ballarith__final;
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  this_final.next = final_list;
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  final_list = &this_final;
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  }
# line 335 "../../../../Macaulay2/d/ballarith.d"
static void ballarith__thread_prepare(){
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  }
# line 335 "../../../../Macaulay2/d/ballarith.d"
static void ballarith__final(){
  # line 335 "../../../../Macaulay2/d/ballarith.d"
  }
