#include "boostmath-exports.h"
#include "scc-core.h"
#include "../system/supervisorinterface.h"
# line 4 "../../../../Macaulay2/d/boostmath.dd"
#include <iostream>
  #include <boost/config.hpp>
  #ifdef HAVE_BOOST_MATH_TOOLS_ATOMIC_HPP
    #include <boost/math/tools/atomic.hpp>
  #endif
  #if defined(BOOST_HAS_THREADS) && \
     (defined(BOOST_NO_CXX11_HDR_MUTEX) || defined(BOOST_MATH_NO_ATOMIC_INT))
  #define BOOST_MATH_BERNOULLI_UNTHREADED
  #endif

  #include <boost/multiprecision/mpfr.hpp>
  #include <boost/math/special_functions/beta.hpp>
  #include <boost/math/special_functions/erf.hpp>
  #include <boost/math/special_functions/gamma.hpp>

  #define RR_TO_BOOST(x) boost::multiprecision::mpfr_float(x)

  #define BOOST_MATH_CALL(f, prec, ...)                                  \
  try {                                                                  \
    boost::multiprecision::mpfr_float::default_precision(                \
	boost::multiprecision::detail::digits2_2_10(prec));              \
    return gmp_toRR(boost::math::f(__VA_ARGS__).backend().data(), prec); \
  } catch (const std::exception& e) {                                    \
      if (!(*((char*)TS_Get_Local(stdiop_SuppressErrors_id))))           \
        std::cout << e.what() << std::endl;                              \
    return nullptr;                                                      \
  }
static M2_string str_;
# line 33 "../../../../Macaulay2/d/boostmath.dd"
static parse_Expr handleBoostError(gmp_RRorNull x){
  # line 33 "../../../../Macaulay2/d/boostmath.dd"
  mpfr_srcptr y;
  # line 33 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp_;
  # line 33 "../../../../Macaulay2/d/boostmath.dd"
  if (0 == x) goto L1_;
  # line 33 "../../../../Macaulay2/d/boostmath.dd"
  goto L0_;
  # line 33 "../../../../Macaulay2/d/boostmath.dd"
  L1_:;
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  tmp_ = expr_buildErrorPacket(str_);
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  goto L2_;
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  L0_:;
  # line 33 "../../../../Macaulay2/d/boostmath.dd"
  y = ((mpfr_srcptr)x);
  # line 35 "../../../../Macaulay2/d/boostmath.dd"
  tmp_ = util_toExpr_16(y);
  # line 35 "../../../../Macaulay2/d/boostmath.dd"
  goto L2_;
  # line 35 "../../../../Macaulay2/d/boostmath.dd"
  L2_:;
  # line 35 "../../../../Macaulay2/d/boostmath.dd"
  return tmp_;
  # line 35 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 39 "../../../../Macaulay2/d/boostmath.dd"
static gmp_RRorNull inverseRegularizedGamma(mpfr_srcptr a,mpfr_srcptr q){
  # line 39 "../../../../Macaulay2/d/boostmath.dd"
  unsigned long prec;
  # line 39 "../../../../Macaulay2/d/boostmath.dd"
  prec = gmp_min_3(gmp_precision(a), gmp_precision(q));
  # line 40 "../../../../Macaulay2/d/boostmath.dd"
  BOOST_MATH_CALL(gamma_q_inv, prec, RR_TO_BOOST(a), RR_TO_BOOST(q));
  # line 40 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 43 "../../../../Macaulay2/d/boostmath.dd"
static parse_Expr inverseRegularizedGamma_1(parse_Expr e){
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Sequence s;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell a_1;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell q_1;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__1;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__2;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__3;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__4;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__5;
  # line 43 "../../../../Macaulay2/d/boostmath.dd"
  switch (e->type_) {;
    # line 43 "../../../../Macaulay2/d/boostmath.dd"
    case 7:;
    # line 43 "../../../../Macaulay2/d/boostmath.dd"
    s = ((parse_Sequence)e);
    # line 44 "../../../../Macaulay2/d/boostmath.dd"
    tmp__1 = s->array[0];
    # line 44 "../../../../Macaulay2/d/boostmath.dd"
    switch (tmp__1->type_) {;
      # line 44 "../../../../Macaulay2/d/boostmath.dd"
      case 54:;
      # line 44 "../../../../Macaulay2/d/boostmath.dd"
      a_1 = ((gmp_RRcell)tmp__1);
      # line 45 "../../../../Macaulay2/d/boostmath.dd"
      tmp__2 = s->array[1];
      # line 45 "../../../../Macaulay2/d/boostmath.dd"
      switch (tmp__2->type_) {;
	# line 45 "../../../../Macaulay2/d/boostmath.dd"
	case 54:;
	# line 45 "../../../../Macaulay2/d/boostmath.dd"
	q_1 = ((gmp_RRcell)tmp__2);
	# line 46 "../../../../Macaulay2/d/boostmath.dd"
	tmp__3 = handleBoostError(inverseRegularizedGamma(a_1->v, q_1->v));
	# line 46 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 46 "../../../../Macaulay2/d/boostmath.dd"
	default:;
	# line 47 "../../../../Macaulay2/d/boostmath.dd"
	tmp__3 = expr_WrongArgRR_1(2);
	# line 47 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 47 "../../../../Macaulay2/d/boostmath.dd"
	};
      # line 47 "../../../../Macaulay2/d/boostmath.dd"
      tmp__4 = tmp__3;
      # line 47 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 47 "../../../../Macaulay2/d/boostmath.dd"
      default:;
      # line 48 "../../../../Macaulay2/d/boostmath.dd"
      tmp__4 = expr_WrongArgRR_1(1);
      # line 48 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 48 "../../../../Macaulay2/d/boostmath.dd"
      };
    # line 48 "../../../../Macaulay2/d/boostmath.dd"
    tmp__5 = tmp__4;
    # line 48 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 48 "../../../../Macaulay2/d/boostmath.dd"
    default:;
    # line 49 "../../../../Macaulay2/d/boostmath.dd"
    tmp__5 = expr_WrongNumArgs_1(2);
    # line 49 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 49 "../../../../Macaulay2/d/boostmath.dd"
    };
  # line 49 "../../../../Macaulay2/d/boostmath.dd"
  return tmp__5;
  # line 49 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 49 "../../../../Macaulay2/d/boostmath.dd"
static M2_string str__1;
# line 54 "../../../../Macaulay2/d/boostmath.dd"
static gmp_RRorNull inverseRegularizedBeta(mpfr_srcptr p,mpfr_srcptr a,mpfr_srcptr b){
  # line 54 "../../../../Macaulay2/d/boostmath.dd"
  unsigned long prec_1;
  # line 54 "../../../../Macaulay2/d/boostmath.dd"
  prec_1 = gmp_min_3(gmp_precision(p), gmp_min_3(gmp_precision(a), gmp_precision(b)));
  # line 55 "../../../../Macaulay2/d/boostmath.dd"
  BOOST_MATH_CALL(ibeta_inv, prec_1, RR_TO_BOOST(a), RR_TO_BOOST(b), RR_TO_BOOST(p));
  # line 55 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 58 "../../../../Macaulay2/d/boostmath.dd"
static parse_Expr inverseRegularizedBeta_1(parse_Expr e){
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  parse_Sequence s_1;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell p_1;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell a_2;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  gmp_RRcell b_1;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__6;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__7;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__8;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__9;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__10;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__11;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  parse_Expr tmp__12;
  # line 58 "../../../../Macaulay2/d/boostmath.dd"
  switch (e->type_) {;
    # line 58 "../../../../Macaulay2/d/boostmath.dd"
    case 7:;
    # line 58 "../../../../Macaulay2/d/boostmath.dd"
    s_1 = ((parse_Sequence)e);
    # line 59 "../../../../Macaulay2/d/boostmath.dd"
    tmp__6 = s_1->array[0];
    # line 59 "../../../../Macaulay2/d/boostmath.dd"
    switch (tmp__6->type_) {;
      # line 59 "../../../../Macaulay2/d/boostmath.dd"
      case 54:;
      # line 59 "../../../../Macaulay2/d/boostmath.dd"
      p_1 = ((gmp_RRcell)tmp__6);
      # line 60 "../../../../Macaulay2/d/boostmath.dd"
      tmp__7 = s_1->array[1];
      # line 60 "../../../../Macaulay2/d/boostmath.dd"
      switch (tmp__7->type_) {;
	# line 60 "../../../../Macaulay2/d/boostmath.dd"
	case 54:;
	# line 60 "../../../../Macaulay2/d/boostmath.dd"
	a_2 = ((gmp_RRcell)tmp__7);
	# line 61 "../../../../Macaulay2/d/boostmath.dd"
	tmp__8 = s_1->array[2];
	# line 61 "../../../../Macaulay2/d/boostmath.dd"
	switch (tmp__8->type_) {;
	  # line 61 "../../../../Macaulay2/d/boostmath.dd"
	  case 54:;
	  # line 61 "../../../../Macaulay2/d/boostmath.dd"
	  b_1 = ((gmp_RRcell)tmp__8);
	  # line 62 "../../../../Macaulay2/d/boostmath.dd"
	  tmp__9 = handleBoostError(inverseRegularizedBeta(p_1->v, a_2->v, b_1->v));
	  # line 62 "../../../../Macaulay2/d/boostmath.dd"
	  break;
	  # line 62 "../../../../Macaulay2/d/boostmath.dd"
	  default:;
	  # line 63 "../../../../Macaulay2/d/boostmath.dd"
	  tmp__9 = expr_WrongArgRR_1(3);
	  # line 63 "../../../../Macaulay2/d/boostmath.dd"
	  break;
	  # line 63 "../../../../Macaulay2/d/boostmath.dd"
	  };
	# line 63 "../../../../Macaulay2/d/boostmath.dd"
	tmp__10 = tmp__9;
	# line 63 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 63 "../../../../Macaulay2/d/boostmath.dd"
	default:;
	# line 64 "../../../../Macaulay2/d/boostmath.dd"
	tmp__10 = expr_WrongArgRR_1(2);
	# line 64 "../../../../Macaulay2/d/boostmath.dd"
	break;
	# line 64 "../../../../Macaulay2/d/boostmath.dd"
	};
      # line 64 "../../../../Macaulay2/d/boostmath.dd"
      tmp__11 = tmp__10;
      # line 64 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 64 "../../../../Macaulay2/d/boostmath.dd"
      default:;
      # line 65 "../../../../Macaulay2/d/boostmath.dd"
      tmp__11 = expr_WrongArgRR_1(1);
      # line 65 "../../../../Macaulay2/d/boostmath.dd"
      break;
      # line 65 "../../../../Macaulay2/d/boostmath.dd"
      };
    # line 65 "../../../../Macaulay2/d/boostmath.dd"
    tmp__12 = tmp__11;
    # line 65 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 65 "../../../../Macaulay2/d/boostmath.dd"
    default:;
    # line 66 "../../../../Macaulay2/d/boostmath.dd"
    tmp__12 = expr_WrongNumArgs_1(3);
    # line 66 "../../../../Macaulay2/d/boostmath.dd"
    break;
    # line 66 "../../../../Macaulay2/d/boostmath.dd"
    };
  # line 66 "../../../../Macaulay2/d/boostmath.dd"
  return tmp__12;
  # line 66 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 66 "../../../../Macaulay2/d/boostmath.dd"
static M2_string str__2;
# line 66 "../../../../Macaulay2/d/boostmath.dd"
static void boostmath__thread_prepare();
# line 66 "../../../../Macaulay2/d/boostmath.dd"
static void boostmath__final();
# line 34 "../../../../Macaulay2/d/boostmath.dd"
void boostmath__prepare(){
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  static struct FUNCTION_CELL this_final, this_thread_prepare;
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  static int called_yet = 0;
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  if (called_yet) return; else called_yet = 1;
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  str_ = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (24)*sizeof(signed char));
  if (0 == str_) outofmem2((size_t)sizeof(struct M2_string_struct) + (24)*sizeof(signed char));
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  str_->len = 24;
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  memcpy(str_->array, "Boost Math Toolkit error", 24);
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  str__1 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (23)*sizeof(signed char));
  if (0 == str__1) outofmem2((size_t)sizeof(struct M2_string_struct) + (23)*sizeof(signed char));
  # line 34 "../../../../Macaulay2/d/boostmath.dd"
  str__1->len = 23;
  # line 50 "../../../../Macaulay2/d/boostmath.dd"
  memcpy(str__1->array, "inverseRegularizedGamma", 23);
  # line 50 "../../../../Macaulay2/d/boostmath.dd"
  str__2 = (M2_string) GC_MALLOC_ATOMIC(sizeof(struct M2_string_struct) + (22)*sizeof(signed char));
  if (0 == str__2) outofmem2((size_t)sizeof(struct M2_string_struct) + (22)*sizeof(signed char));
  # line 50 "../../../../Macaulay2/d/boostmath.dd"
  str__2->len = 22;
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  memcpy(str__2->array, "inverseRegularizedBeta", 22);
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  util__prepare();
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  common__prepare();
  # line 50 "../../../../Macaulay2/d/boostmath.dd"
  common_setupfun(str__1, inverseRegularizedGamma_1)->Protected = 0;
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  common_setupfun(str__2, inverseRegularizedBeta_1)->Protected = 0;
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  this_thread_prepare.func = boostmath__thread_prepare;
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  this_thread_prepare.next = thread_prepare_list;
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  thread_prepare_list = &this_thread_prepare;
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  this_final.func = boostmath__final;
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  this_final.next = final_list;
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  final_list = &this_final;
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 67 "../../../../Macaulay2/d/boostmath.dd"
static void boostmath__thread_prepare(){
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  }
# line 67 "../../../../Macaulay2/d/boostmath.dd"
static void boostmath__final(){
  # line 67 "../../../../Macaulay2/d/boostmath.dd"
  }
