#ifndef interrupts_included
#define interrupts_included

#ifndef _GNU_SOURCE
 #define _GNU_SOURCE
#endif
#include <stdint.h>
#define hash_t uint64_t

  #include "M2/atomic-field.h"
  #ifdef __cplusplus
    #include <atomic>
    using std::atomic_fetch_add;
    using std::atomic_signal_fence;
    using std::memory_order_seq_cst;
  #else
    #include <stdatomic.h>
  #endif
  

#define interrupted() test_Field(THREADLOCAL(interrupts_interruptedFlag,struct atomic_field))

/* included from ../../../../Macaulay2/c/scc1.c*/

#ifdef __cplusplus
  #define BASECLASS : public our_new_delete
  #include "newdelete.hpp"
#else
  #define BASECLASS
#endif

#if defined(__cplusplus)
  extern "C" {
#endif

#ifndef SAFEC_EXPORTS
#define SAFEC_EXPORTS
#endif
#ifndef SAFEC_basic_typedefs_defined
#define SAFEC_basic_typedefs_defined
typedef char M2_bool;
struct tagged_union { unsigned short type_; };
#undef M2_basic_typedefs_defined
#endif

/* typedefs */
typedef struct atomic_field atomic_atomicField;
/* array types */
/* struct types */
/* basic types */
/* functions */
extern void interrupts__prepare() __attribute__ ((constructor));
extern void interrupts_clearSteppingFlag();
extern int interrupts_microStepCount;
extern int interrupts_stepCount;
extern void interrupts_clearAlarmedFlag();
extern void interrupts_clearInterruptFlag();
extern void interrupts_setSteppingFlag();
extern void interrupts_setAlarmedFlag();
extern void interrupts_setInterruptFlag();
extern void interrupts_clearAllFlags();
extern void interrupts_clearAlarm();
extern void interrupts_determineExceptionFlag();
extern int interrupts_exceptionFlag_id;
extern int interrupts_interruptedFlag_id;
extern int interrupts_steppingFlag_id;
extern int interrupts_alarmedFlag_id;
extern int interrupts_interruptPending_id;
extern int interrupts_interruptShield_id;
extern void atomic__prepare() __attribute__ ((constructor));
extern void arithmetic__prepare() __attribute__ ((constructor));

#if defined(__cplusplus)
  }
#endif

#endif
